package com.gingersoft.supply_chain.mvp.model;

import android.app.Application;

import com.gingersoft.gsa.cloud.common.bean.BaseResult;
import com.gingersoft.supply_chain.mvp.bean.FoodCategoryResultBean;
import com.gingersoft.supply_chain.mvp.bean.OrderCategoryBean;
import com.gingersoft.supply_chain.mvp.contract.CategoryContract;
import com.gingersoft.supply_chain.mvp.server.SupplierServer;
import com.google.gson.Gson;
import com.jess.arms.di.scope.FragmentScope;
import com.jess.arms.integration.IRepositoryManager;
import com.jess.arms.mvp.BaseModel;

import java.util.Map;

import javax.inject.Inject;

import io.reactivex.Observable;
import okhttp3.RequestBody;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 11/28/2020 10:14
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
@FragmentScope
public class CategoryModel extends BaseModel implements CategoryContract.Model {
    @Inject
    Gson mGson;
    @Inject
    Application mApplication;

    @Inject
    public CategoryModel(IRepositoryManager repositoryManager) {
        super(repositoryManager);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        this.mGson = null;
        this.mApplication = null;
    }


    @Override
    public Observable<FoodCategoryResultBean> getFoodCategoryList(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).getFoodCategoryList(map);
    }

    @Override
    public Observable<OrderCategoryBean> getCategoryTrees(Map<String, Object> map) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).getCategoryTrees(map);
    }

    @Override
    public Observable<BaseResult> createFoodCategory(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).addFoodCategory(requestBody);
    }

    @Override
    public Observable<BaseResult> updateFoodCategory(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).updateFoodCategory(requestBody);
    }

    @Override
    public Observable<BaseResult> deleteFoodCategory(RequestBody requestBody) {
        return mRepositoryManager.obtainRetrofitService(SupplierServer.class).deleteFoodCategory(requestBody);
    }
}